
require 'em-websocket'
require 'json'


EventMachine.run {
  channel = EM::Channel.new

  EM.start_server(
    '127.0.0.1',
    2018,
    Class.new(EM::Connection) do
      define_method(:receive_data) do |data|
        seq, command = *JSON.parse(data)
        channel.push(command)
      end
    end
  )

  EM::WebSocket.start(:host => '127.0.0.1', :port => 2017, :debug => false) do |ws|
    ws.onopen do
      sid = channel.subscribe {|message| ws.send(message.to_json) }
      ws.onclose { channel.unsubscribe(sid) }
    end
  end

  puts 'Server started'
}

